## fastcdr 2.2.6+really2.2.5

=== src/cpp/CMakeLists.txt ===
# Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

file(GLOB_RECURSE ALL_HEADERS
    ${PROJECT_SOURCE_DIR}/include/**/*.h
    ${PROJECT_SOURCE_DIR}/include/**/*.hpp
    ${PROJECT_SOURCE_DIR}/src/cpp/**/*.h
    ${PROJECT_SOURCE_DIR}/src/cpp/**/*.hpp
    )

# Set source files
set(${PROJECT_NAME}_source_files
    ${ALL_HEADERS}

    Cdr.cpp
    CdrSizeCalculator.cpp
    FastCdr.cpp
    FastBuffer.cpp
    exceptions/BadOptionalAccessException.cpp
    exceptions/BadParamException.cpp
    exceptions/Exception.cpp
    exceptions/LockedExternalAccessException.cpp
    exceptions/NotEnoughMemoryException.cpp
    FastCdr.rc
    )

configure_file(${PROJECT_SOURCE_DIR}/include/${PROJECT_NAME}/config.h.in
    ${PROJECT_BINARY_DIR}/include/${PROJECT_NAME}/config.h)

if(APPLE)
    set(CMAKE_MACOSX_RPATH ON)
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
endif()

# Create library
add_library(${PROJECT_NAME} ${${PROJECT_NAME}_source_files})
set_common_compile_options(${PROJECT_NAME})
set_target_properties(${PROJECT_NAME} PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
    )

target_compile_definitions(${PROJECT_NAME}
    PRIVATE
    ${PROJECT_NAME_UPPER}_SOURCE
    INTERFACE
    $<$<BOOL:${WIN32}>:${PROJECT_NAME_UPPER}_NO_LIB>
    PUBLIC
    $<$<STREQUAL:$<TARGET_PROPERTY:${PROJECT_NAME},TYPE>,SHARED_LIBRARY>:${PROJECT_NAME_UPPER}_DYN_LINK>
    )

# Define public headers
target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include> $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
    )

if(MSVC OR MSVC_IDE)
    set_target_properties(${PROJECT_NAME} PROPERTIES
        RELEASE_POSTFIX -${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
        RELWITHDEBINFO_POSTFIX -${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
        DEBUG_POSTFIX d-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
        )

    get_target_property(TARGET_TYPE ${PROJECT_NAME} TYPE)
    if(TARGET_TYPE STREQUAL "SHARED_LIBRARY")
        # Export symbols in DLL library
        set_target_properties(${PROJECT_NAME} PROPERTIES
            PDB_NAME_DEBUG ${PROJECT_NAME}d-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
            PDB_OUTPUT_DIRECTORY_DEBUG "${CMAKE_CURRENT_BINARY_DIR}/symbols"
            )
    else()
        # Rename the library to have a "lib" before.
        set_target_properties(${PROJECT_NAME} PROPERTIES
            OUTPUT_NAME lib${PROJECT_NAME}
            COMPILE_PDB_NAME_DEBUG lib${PROJECT_NAME}d-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
            COMPILE_PDB_OUTPUT_DIRECTORY_DEBUG "${CMAKE_CURRENT_BINARY_DIR}/symbols"
            )
    endif()
endif()

###############################################################################
# Packaging
###############################################################################

# Install public headers
install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/${PROJECT_NAME}
    DESTINATION ${INCLUDE_INSTALL_DIR}
    COMPONENT headers
    FILES_MATCHING
    PATTERN "*.h"
    PATTERN "*.hpp"
    PATTERN "*.ipp"
    )

# Install config.h header
install(FILES ${PROJECT_BINARY_DIR}/include/${PROJECT_NAME}/config.h
    DESTINATION ${INCLUDE_INSTALL_DIR}/${PROJECT_NAME}
    COMPONENT headers
    )

# Install libraries
install(TARGETS ${PROJECT_NAME}
    EXPORT ${PROJECT_NAME}-targets
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
    COMPONENT libraries
    )

# Generate different target names depending on linking
get_target_property(TARGET_TYPE ${PROJECT_NAME} TYPE)
if(TARGET_TYPE STREQUAL "SHARED_LIBRARY")
    set(FASTCDR_LINKING shared)
else()
    set(FASTCDR_LINKING static)
endif()

if(INSTALLER_PLATFORM)
    set(INSTALL_DESTINATION_PATH ${DATA_INSTALL_DIR}/${PROJECT_NAME}-${INSTALLER_PLATFORM}/cmake)
else()
    set(INSTALL_DESTINATION_PATH ${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME})
endif()

install(EXPORT ${PROJECT_NAME}-targets
    DESTINATION ${INSTALL_DESTINATION_PATH}
    FILE ${PROJECT_NAME}-${FASTCDR_LINKING}-targets.cmake
    COMPONENT cmake
    )

if(MSVC OR MSVC_IDE)
    # first try dll symbols
    get_target_property(PDB_FILE ${PROJECT_NAME} PDB_NAME_DEBUG)
    if(PDB_FILE)
        get_target_property(PDB_DIR ${PROJECT_NAME} PDB_OUTPUT_DIRECTORY_DEBUG)
        set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
    else()
        # fallback to static lib symbols
        get_target_property(PDB_FILE ${PROJECT_NAME} COMPILE_PDB_NAME_DEBUG)
        if(PDB_FILE)
            get_target_property(PDB_DIR ${PROJECT_NAME} COMPILE_PDB_OUTPUT_DIRECTORY_DEBUG)
            set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
        endif()
    endif()

    # install symbols if any
    if(PDB_FILE)
        install(FILES ${PDB_FILE}
            DESTINATION ${LIB_INSTALL_DIR}
            COMPONENT symbols
            CONFIGURATIONS Debug
            )
    endif()
endif()

###############################################################################
# Create CMake package config file
###############################################################################
include(CMakePackageConfigHelpers)

if(BUILD_SHARED_LIBS)
    set(FASTCDR_PACKAGE_OPT_BIN_DIR_CONDITION "if(MSVC OR MSVC_IDE)")
else()
    set(FASTCDR_PACKAGE_OPT_BIN_DIR_CONDITION "if(0)")
endif()

configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/packaging/Config.cmake.in
    ${PROJECT_BINARY_DIR}/cmake/config/${PROJECT_NAME}-config.cmake
    INSTALL_DESTINATION ${INSTALL_DESTINATION_PATH}
    PATH_VARS BIN_INSTALL_DIR INCLUDE_INSTALL_DIR LIB_INSTALL_DIR
    )
write_basic_package_version_file(${PROJECT_BINARY_DIR}/cmake/config/${PROJECT_NAME}-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
    )
install(FILES ${PROJECT_BINARY_DIR}/cmake/config/${PROJECT_NAME}-config.cmake
    ${PROJECT_BINARY_DIR}/cmake/config/${PROJECT_NAME}-config-version.cmake
    DESTINATION ${INSTALL_DESTINATION_PATH}
    COMPONENT cmake
    )

=== debian/changelog ===
fastcdr (2.2.6+really2.2.5-1ubuntu1) questing; urgency=medium

  * d/libfastcdr2.symbols: mark symbols as optional to fix FTBFS in ppc64el.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 04 May 2025 17:24:19 +0100

fastcdr (2.2.6+really2.2.5-1) unstable; urgency=medium

  * Revert to previous patch release due to unexpected ABI break.

 -- Timo Röhling <roehling@debian.org>  Thu, 27 Feb 2025 12:00:04 +0100

fastcdr (2.2.6-1) unstable; urgency=medium

  * New upstream version 2.2.6
  * Refresh patches (no functional changes)
  * Bump Standards-Version to 4.7.1
  * Wrap and sort Debian package files
  * Add new symbols

 -- Timo Röhling <roehling@debian.org>  Wed, 26 Feb 2025 15:30:23 +0100

=== debian/control ===
Source: fastcdr
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders:
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 cmake,
 doxygen <!nodoc>,
 graphviz <!nodoc>,
 libgtest-dev <!nocheck>,
 ninja-build,
 pkg-kde-tools,
Standards-Version: 4.7.1
Rules-Requires-Root: no
Homepage: https://github.com/eProsima/Fast-CDR
Vcs-Git: https://salsa.debian.org/robotics-team/fastcdr.git
Vcs-Browser: https://salsa.debian.org/robotics-team/fastcdr
Description: Fast CDR serialization library for DDS
 eProsima FastCDR is a C++ library that provides serialization and
 deserialization according to the Common Data Representation (CDR) of the Data
 Distribution Service (DDS) standard and is part of the eProsima FastDDS
 implementation.

Package: libfastcdr2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}

Package: libfastcdr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libfastcdr2 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} - development headers
 ${source:Extended-Description}
 .
 This package installs the development headers.

Package: libfastcdr-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends},
Description: ${source:Synopsis} - API documentation
 ${source:Extended-Description}
 .
 This package installs the API documentation.

## fastcdr 2.3.1

=== CMakeLists.txt ===
# Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

###############################################################################
# CMake build rules for FastCDR                                               #
###############################################################################
cmake_minimum_required(VERSION 3.20)

# Set CMAKE_BUILD_TYPE to Release by default.
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to 'Release' as none was specified.")
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Set BUILD_TESTING to OFF by default.
if(NOT BUILD_TESTING)
    message(STATUS "Tests not compiled by default")
    set(BUILD_TESTING OFF CACHE BOOL "Enable testing" FORCE)
endif()

###############################################################################
# Project                                                                     #
###############################################################################
project(fastcdr VERSION 2.3.1 LANGUAGES CXX)

set(PROJECT_NAME_STYLED "FastCDR")
set(PROJECT_NAME_LARGE "Fast CDR")
string(TOUPPER "${PROJECT_NAME}" PROJECT_NAME_UPPER)
set(${PROJECT_NAME}_DESCRIPTION_SUMMARY "C++ library for serialize using CDR serialization")
set(${PROJECT_NAME}_DESCRIPTION "eProsima ${PROJECT_NAME_LARGE} library provides two serialization mechanisms. One is the standard CDR serialization mechanism, while the other is a faster implementation that modifies the standard.")

message(STATUS "Configuring ${PROJECT_NAME_LARGE}")
message(STATUS "Version: ${PROJECT_VERSION}")

###############################################################################
# CCache on Windows on CI
###############################################################################
if (MSVC AND CMAKE_CXX_COMPILER_LAUNCHER STREQUAL "ccache")
    foreach(config DEBUG RELWITHDEBINFO)
        foreach(lang C CXX)
            set(flags_var "CMAKE_${lang}_FLAGS_${config}")
            string(REPLACE "/Zi" "/Z7" ${flags_var} "${${flags_var}}")
            set(${flags_var} "${${flags_var}}")
        endforeach()
    endforeach()
endif()

###############################################################################
# GCC colors if using CCache
###############################################################################
if("${CMAKE_CXX_COMPILER_LAUNCHER}" STREQUAL "ccache" AND
        CMAKE_COMPILER_IS_GNUCXX AND
        CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4,8)
    add_compile_options(-fdiagnostics-color=always)
endif()

###############################################################################
# Default shared libraries
###############################################################################
# Global flag to cause add_library() to create shared libraries if on.
# If set to true, this will cause all libraries to be built shared
# unless the library was explicitly added as a static library.
option(BUILD_SHARED_LIBS "Create shared libraries by default" ON)

###############################################################################
# Test system configuration
###############################################################################
include(${PROJECT_SOURCE_DIR}/cmake/common/check_configuration.cmake)

set(FORCE_CXX "11" CACHE STRING "C++ standard fulfillment selection")
check_stdcxx(${FORCE_CXX})

check_endianness()
check_type_sizes()

###############################################################################
# Check MSVC architecture
###############################################################################
if(MSVC OR MSVC_IDE)
    check_msvc_arch()
endif()

###############################################################################
# Installation paths
###############################################################################
option(APPEND_PROJECT_NAME_TO_INCLUDEDIR
  "When ON headers are installed to a path ending with a folder called \
  ${PROJECT_NAME}. This avoids include directory search order issues when \
  overriding this package from a merged catkin, ament, or colcon workspace."
  OFF)

set(BIN_INSTALL_DIR bin/ CACHE PATH "Installation directory for binaries")
set(_include_dir "include/")
if(APPEND_PROJECT_NAME_TO_INCLUDEDIR)
  string(APPEND _include_dir "${PROJECT_NAME}/")
endif()
set(INCLUDE_INSTALL_DIR "${_include_dir}" CACHE PATH "Installation directory for C++ headers")
unset(_include_dir)
set(LIB_INSTALL_DIR lib${LIB_SUFFIX}/ CACHE PATH "Installation directory for libraries")
set(DATA_INSTALL_DIR share/ CACHE PATH "Installation directory for data")
if(WIN32)
    set(DOC_DIR "doc")
else()
    set(DOC_DIR "${DATA_INSTALL_DIR}/doc")
endif()
set(DOC_INSTALL_DIR ${DOC_DIR} CACHE PATH "Installation directory for documentation")
set(LICENSE_INSTALL_DIR ${DATA_INSTALL_DIR}/${PROJECT_NAME} CACHE PATH "Installation directory for licenses")

###############################################################################
# Compile library.
###############################################################################
add_subdirectory(src/cpp)

###############################################################################
# Testing
###############################################################################
enable_testing()
include(CTest)

if (BUILD_TESTING)
    if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.22)
        add_subdirectory(test)
    else()
        message(INFO "Tests are disabled because the version of CMake is less than 3.22")
    endif()
endif()

###############################################################################
# Documentation
###############################################################################
# Add an option to toggle the generation of the API documentation.
option(BUILD_DOCUMENTATION "Use doxygen to create product documentation" OFF)
option(CHECK_DOCUMENTATION "Use doxygen to check code documentation" OFF)
option(GENERATE_PDF_DOC "Use doxygen to generate API Reference PDF" OFF)

if(CHECK_DOCUMENTATION)
    set(BUILD_DOCUMENTATION ON)
endif()

if(BUILD_DOCUMENTATION)
    find_package(Doxygen)
    if(NOT DOXYGEN_FOUND)
        message(FATAL_ERROR "doxygen is needed to build the documentation. Please install it correctly")
    endif()
    if(UNIX)
        find_program(DOXYFILE_MAKE make)
        if(DOXYFILE_MAKE)
            message(STATUS "Found Make: ${DOXYFILE_MAKE}")
        else()
            message(FATAL_ERROR "make is needed to build the documentation. Please install it correctly")
        endif()
    elseif(WIN32)
        set(DOXYFILE_MAKE make.bat)
    endif()

    if(NOT CHECK_DOCUMENTATION)
        find_program(WGET_EXE wget)
        if(WGET_EXE)
            message(STATUS "Found WGet: ${WGET_EXE}")
        else()
            message(FATAL_ERROR "wget is needed to build the documentation. Please install it correctly")
        endif()
        find_program(UNZIP_EXE unzip)
        if(UNZIP_EXE)
            message(STATUS "Found Unzip: ${UNZIP_EXE}")
        else()
            message(FATAL_ERROR "unzip is needed to build the documentation. Please install it correctly")
        endif()
    endif()

    # Target to create documentation directories
    add_custom_target(docdirs
        COMMAND ${CMAKE_COMMAND} -E make_directory ${PROJECT_BINARY_DIR}/doc
        COMMENT "Creating documentation directory" VERBATIM)

    ### Doxygen ########################3
    if(CHECK_DOCUMENTATION)
        set(USE_DOT NO)
    else()
        set(USE_DOT YES)
    endif()
    if(GENERATE_PDF_DOC)
        set(GENERATE_LATEX YES)
    else()
        set(GENERATE_LATEX NO)
    endif()
    # Configure the template doxyfile for or specific project
    configure_file(doxyfile.in ${PROJECT_BINARY_DIR}/doxyfile @ONLY IMMEDIATE)
    # Add custom target to run doxygen when ever the project is build
    add_custom_target(doxygen
        COMMAND "${DOXYGEN_EXECUTABLE}" "${PROJECT_BINARY_DIR}/doxyfile"
        SOURCES "${PROJECT_BINARY_DIR}/doxyfile"
        COMMENT "Generating API documentation with doxygen" VERBATIM)

    add_dependencies(doxygen docdirs)

    if(GENERATE_PDF_DOC)
        add_custom_target(make_pdf ALL
            COMMAND "make" "pdf"
            WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/doxygen/latex
            COMMENT "Generating API reference PDF" VERBATIM)

        add_dependencies(make_pdf doxygen)
    endif()

    ### README html ########################

    if(WIN32)
        set(README_LOCATION "${PROJECT_BINARY_DIR}/")
        set(README_LOCATION_PREFFIX "doc/")
        set(README_INSTALL_LOCATION ".")
    else()
        set(README_LOCATION "${PROJECT_BINARY_DIR}/doc/")
        set(README_INSTALL_LOCATION "${DOC_INSTALL_DIR}")
    endif()

    configure_file(doc/README.html.in ${README_LOCATION}/README.html @ONLY IMMEDIATE)

    add_custom_target(doc ALL
        COMMENT "Generated project documentation" VERBATIM)

    add_dependencies(doc doxygen)
endif()


###############################################################################
# Packaging
###############################################################################
# Install licenses
install(FILES ${PROJECT_SOURCE_DIR}/LICENSE
    DESTINATION ${LICENSE_INSTALL_DIR}
    COMPONENT licenses
    )

if(BUILD_DOCUMENTATION)

    # Instalation of doxygen files
    install(DIRECTORY ${PROJECT_BINARY_DIR}/doc/api_reference
        DESTINATION ${DOC_INSTALL_DIR}
        COMPONENT documentation
        )

    install(FILES "${README_LOCATION}/README.html"
        DESTINATION ${README_INSTALL_LOCATION}
        COMPONENT documentation
        )

    if(GENERATE_PDF_DOC)
        install(FILES "${PROJECT_BINARY_DIR}/doxygen/latex/refman.pdf"
        DESTINATION ${DOC_INSTALL_DIR}
        RENAME fastcdr-${PROJECT_VERSION}-api-reference.pdf
        COMPONENT documentation)
    endif()
endif()

=== src/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -60,7 +60,7 @@
     INTERFACE
     $<$<BOOL:${WIN32}>:${PROJECT_NAME_UPPER}_NO_LIB>
     PUBLIC
-    $<$<STREQUAL:$<TARGET_PROPERTY:${PROJECT_NAME},TYPE>,SHARED_LIBRARY>:${PROJECT_NAME_UPPER}_DYN_LINK>
+    $<$<TARGET_EXISTS:${PROJECT_NAME}>:$<$<STREQUAL:$<TARGET_PROPERTY:${PROJECT_NAME},TYPE>,SHARED_LIBRARY>:${PROJECT_NAME_UPPER}_DYN_LINK>>
     )
 
 # Define public headers

=== debian/changelog ===
fastcdr (2.3.1-2) unstable; urgency=medium

  * Fix architecture-specific symbol substitutions
  * Migrate debian/watch to version 5 format

 -- Timo Röhling <roehling@debian.org>  Mon, 22 Sep 2025 13:08:51 +0200

fastcdr (2.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * Update patches.
    Obsolete: 0002-Fix-visibility-of-exception-classes.patch
  * Bump Standards-Version to 4.7.2
  * Update symbols

 -- Timo Röhling <roehling@debian.org>  Mon, 22 Sep 2025 11:57:42 +0200

## fastcdr 2.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 ###############################################################################
 # Project                                                                     #
 ###############################################################################
-project(fastcdr VERSION 2.3.1 LANGUAGES CXX)
+project(fastcdr VERSION 2.3.2 LANGUAGES CXX)
 
 set(PROJECT_NAME_STYLED "FastCDR")
 set(PROJECT_NAME_LARGE "Fast CDR")

=== src/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -148,7 +148,7 @@
     if(PDB_FILE)
         get_target_property(PDB_DIR ${PROJECT_NAME} PDB_OUTPUT_DIRECTORY_DEBUG)
         set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
-    else()
+    elseif(NOT CMAKE_CXX_COMPILER_LAUNCHER STREQUAL "ccache")
         # fallback to static lib symbols
         get_target_property(PDB_FILE ${PROJECT_NAME} COMPILE_PDB_NAME_DEBUG)
         if(PDB_FILE)

=== debian/changelog ===
fastcdr (2.3.2-1) unstable; urgency=medium

  * New upstream version 2.3.2
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 30 Sep 2025 16:05:13 +0200

## fastcdr 2.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 ###############################################################################
 # Project                                                                     #
 ###############################################################################
-project(fastcdr VERSION 2.3.2 LANGUAGES CXX)
+project(fastcdr VERSION 2.3.3 LANGUAGES CXX)
 
 set(PROJECT_NAME_STYLED "FastCDR")
 set(PROJECT_NAME_LARGE "Fast CDR")

=== test/CMakeLists.txt ===
# Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Require C++ 14 for testing (since ROS 2 requires it anyways)
set(FORCE_CXX "14")
check_stdcxx(${FORCE_CXX})

# Find GTest
include(${PROJECT_SOURCE_DIR}/cmake/common/find_or_add_gtest.cmake)
find_or_add_gtest()

# Include functions to find and add tests dinamically
include(${PROJECT_SOURCE_DIR}/cmake/testing/GoogleTest.cmake)

add_subdirectory(cdr)
add_subdirectory(xcdr)

###############################################################################
# CMake modules tests
###############################################################################

set(build_dir "${fastcdr_BINARY_DIR}/test/force_cxx")
set(module_dir "${fastcdr_SOURCE_DIR}/cmake/common")
set(script "${CMAKE_CURRENT_LIST_DIR}/cmake/build.cmake")

# The C++ sources use fold expressions which were introduced in C++17

# Tests that C++17 sources can be built enforcing C++17 through CMake
add_test(NAME cmake.force_standard.positive.builtin
        COMMAND ${CMAKE_COMMAND}
                -DFORCE_CXX=17 -DTEST_FALLBACK=OFF
                -DEPROSIMA_MODULE_PATH=${module_dir}
                -DBUILD_DIR=${build_dir}
                -P ${script}
        )

# Tests that C++17 sources can be built enforcing C++17 manually
add_test(NAME cmake.force_standard.positive.manual
        COMMAND ${CMAKE_COMMAND}
                -DFORCE_CXX=17 -DTEST_FALLBACK=ON
                -DEPROSIMA_MODULE_PATH=${module_dir}
                -DBUILD_DIR=${build_dir}
                -P ${script}
        )

# Tests that C++17 sources cannot be built enforcing C++14 through CMake
add_test(NAME cmake.force_standard.negative.builtin
        COMMAND ${CMAKE_COMMAND}
                -DFORCE_CXX=14 -DTEST_FALLBACK=OFF
                -DEPROSIMA_MODULE_PATH=${module_dir}
                -DBUILD_DIR=${build_dir}
                -P ${script}
        )

# Tests that C++17 sources cannot be built enforcing C++14 manually
add_test(NAME cmake.force_standard.negative.manual
        COMMAND ${CMAKE_COMMAND}
                -DFORCE_CXX=14 -DTEST_FALLBACK=ON
                -DEPROSIMA_MODULE_PATH=${module_dir}
                -DBUILD_DIR=${build_dir}
                -P ${script}
        )

# set the negative testing
set_tests_properties(
    cmake.force_standard.negative.builtin
    cmake.force_standard.negative.manual
    PROPERTIES WILL_FAIL TRUE)

=== test/cdr/CMakeLists.txt ===
# Copyright 2023 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

###############################################################################
# fixed_size_string tests
###############################################################################
add_executable(FixedSizeStringTests fixed_size_string.cpp)
set_common_compile_options(FixedSizeStringTests)
target_link_libraries(FixedSizeStringTests fastcdr GTest::gtest_main)
gtest_discover_tests(FixedSizeStringTests)

###############################################################################
# array_as_std_vector tests
###############################################################################
add_executable(ArrayAsSTDVectorTests array_as_std_vector.cpp)
set_common_compile_options(ArrayAsSTDVectorTests)
target_link_libraries(ArrayAsSTDVectorTests fastcdr GTest::gtest_main)
gtest_discover_tests(ArrayAsSTDVectorTests)

###############################################################################
# Old cdr unit tests
###############################################################################
set(UNITTESTS_SOURCE SimpleTest.cpp ResizeTest.cpp)
add_executable(UnitTests ${UNITTESTS_SOURCE})
set_common_compile_options(UnitTests)
target_link_libraries(UnitTests fastcdr GTest::gtest_main)
gtest_discover_tests(UnitTests)

=== test/xcdr/CMakeLists.txt ===
# Copyright 2023 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

###############################################################################
# Unit tests for XCDR extensions
###############################################################################
set(XCDR_TEST_SOURCE
    appendable.cpp
    basic_types.cpp
    external.cpp
    final.cpp
    mutable.cpp
    optional.cpp
    xcdrv1.cpp
    xcdrv2.cpp
    )
add_executable(xcdr_tests ${XCDR_TEST_SOURCE})
set_common_compile_options(xcdr_tests)
target_link_libraries(xcdr_tests fastcdr GTest::gtest_main)
gtest_discover_tests(xcdr_tests)

=== debian/changelog ===
fastcdr (2.3.3-1) unstable; urgency=medium

  * New upstream version 2.3.3
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Fri, 17 Oct 2025 22:22:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: fastcdr
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
+Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
 Uploaders:
  Timo Röhling <roehling@debian.org>,
 Build-Depends:
@@ -14,7 +13,7 @@
  libgtest-dev <!nocheck>,
  ninja-build,
  pkg-kde-tools,
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/eProsima/Fast-CDR
 Vcs-Git: https://salsa.debian.org/robotics-team/fastcdr.git

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs

include /usr/share/dpkg/architecture.mk

BUILD_TESTING = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
BUILD_DOCS = $(if $(filter nodoc,$(DEB_BUILD_OPTIONS)),OFF,ON)

%:
	dh $@ --buildsystem=cmake+ninja --with pkgkde_symbolshelper

override_dh_autoreconf:

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake+ninja -- \
		-DBUILD_TESTING=$(BUILD_TESTING) \
		-DBUILD_DOCUMENTATION=$(BUILD_DOCS) \
		-DCMAKE_CXX_FLAGS_NONE="-fvisibility=hidden -fvisibility-inlines-hidden" \
		-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

execute_after_dh_auto_install:
	rm debian/tmp/usr/share/fastcdr/LICENSE
	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/fastcdr
	mv debian/tmp/usr/include/fastcdr/config.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/fastcdr/config.h

execute_after_dh_installdocs-indep:
	ln -sf /usr/share/javascript/jquery/jquery.min.js debian/libfastcdr-doc/usr/share/doc/libfastcdr-dev/api_reference/jquery.js

=== debian/tests/control ===
Tests:
 run-test-suite,
Depends:
 cmake,
 g++ | c++-compiler,
 libfastcdr-dev,
 libgtest-dev,
Restrictions:
 allow-stderr,

=== debian/watch ===
Version: 5

Template: Github
Owner: eProsima
Project: Fast-CDR
Uversion-Mangle: auto

## fastcdr 2.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 ###############################################################################
 # Project                                                                     #
 ###############################################################################
-project(fastcdr VERSION 2.3.3 LANGUAGES CXX)
+project(fastcdr VERSION 2.3.4 LANGUAGES CXX)
 
 set(PROJECT_NAME_STYLED "FastCDR")
 set(PROJECT_NAME_LARGE "Fast CDR")
@@ -45,19 +45,6 @@
 
 message(STATUS "Configuring ${PROJECT_NAME_LARGE}")
 message(STATUS "Version: ${PROJECT_VERSION}")
-
-###############################################################################
-# CCache on Windows on CI
-###############################################################################
-if (MSVC AND CMAKE_CXX_COMPILER_LAUNCHER STREQUAL "ccache")
-    foreach(config DEBUG RELWITHDEBINFO)
-        foreach(lang C CXX)
-            set(flags_var "CMAKE_${lang}_FLAGS_${config}")
-            string(REPLACE "/Zi" "/Z7" ${flags_var} "${${flags_var}}")
-            set(${flags_var} "${${flags_var}}")
-        endforeach()
-    endforeach()
-endif()
 
 ###############################################################################
 # GCC colors if using CCache

=== src/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -148,12 +148,15 @@
     if(PDB_FILE)
         get_target_property(PDB_DIR ${PROJECT_NAME} PDB_OUTPUT_DIRECTORY_DEBUG)
         set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
-    elseif(NOT CMAKE_CXX_COMPILER_LAUNCHER STREQUAL "ccache")
+    else()
         # fallback to static lib symbols
-        get_target_property(PDB_FILE ${PROJECT_NAME} COMPILE_PDB_NAME_DEBUG)
-        if(PDB_FILE)
-            get_target_property(PDB_DIR ${PROJECT_NAME} COMPILE_PDB_OUTPUT_DIRECTORY_DEBUG)
-            set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
+        get_target_property(MSVC_DEBUG_INFORMATION_FORMAT ${PROJECT_NAME} MSVC_DEBUG_INFORMATION_FORMAT)
+        if(NOT MSVC_DEBUG_INFORMATION_FORMAT MATCHES ".*Embedded.*")
+            get_target_property(PDB_FILE ${PROJECT_NAME} COMPILE_PDB_NAME_DEBUG)
+            if(PDB_FILE)
+                get_target_property(PDB_DIR ${PROJECT_NAME} COMPILE_PDB_OUTPUT_DIRECTORY_DEBUG)
+                set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
+            endif()
         endif()
     endif()

=== debian/changelog ===
fastcdr (2.3.4-1) unstable; urgency=medium

  * New upstream version 2.3.4
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Sun, 09 Nov 2025 20:31:11 +0100

## fastcdr 2.3.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 ###############################################################################
 # Project                                                                     #
 ###############################################################################
-project(fastcdr VERSION 2.3.4 LANGUAGES CXX)
+project(fastcdr VERSION 2.3.5 LANGUAGES CXX)
 
 set(PROJECT_NAME_STYLED "FastCDR")
 set(PROJECT_NAME_LARGE "Fast CDR")
@@ -90,21 +90,17 @@
   overriding this package from a merged catkin, ament, or colcon workspace."
   OFF)
 
-set(BIN_INSTALL_DIR bin/ CACHE PATH "Installation directory for binaries")
-set(_include_dir "include/")
+include(GNUInstallDirs)
+set(BIN_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}" CACHE PATH "Installation directory for binaries")
+set(_include_dir "${CMAKE_INSTALL_INCLUDEDIR}")
 if(APPEND_PROJECT_NAME_TO_INCLUDEDIR)
   string(APPEND _include_dir "${PROJECT_NAME}/")
 endif()
 set(INCLUDE_INSTALL_DIR "${_include_dir}" CACHE PATH "Installation directory for C++ headers")
 unset(_include_dir)
-set(LIB_INSTALL_DIR lib${LIB_SUFFIX}/ CACHE PATH "Installation directory for libraries")
-set(DATA_INSTALL_DIR share/ CACHE PATH "Installation directory for data")
-if(WIN32)
-    set(DOC_DIR "doc")
-else()
-    set(DOC_DIR "${DATA_INSTALL_DIR}/doc")
-endif()
-set(DOC_INSTALL_DIR ${DOC_DIR} CACHE PATH "Installation directory for documentation")
+set(LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}" CACHE PATH "Installation directory for libraries")
+set(DATA_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}" CACHE PATH "Installation directory for data")
+set(DOC_INSTALL_DIR ${CMAKE_INSTALL_DOCDIR} CACHE PATH "Installation directory for documentation")
 set(LICENSE_INSTALL_DIR ${DATA_INSTALL_DIR}/${PROJECT_NAME} CACHE PATH "Installation directory for licenses")
 
 ###############################################################################

=== debian/changelog ===
fastcdr (2.3.5-1) unstable; urgency=medium

  * New upstream version 2.3.5
  * Refresh patches (no functional changes)
  * Bump Standards-Version to 4.7.3

 -- Timo Röhling <roehling@debian.org>  Sat, 07 Feb 2026 18:29:52 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  libgtest-dev <!nocheck>,
  ninja-build,
  pkg-kde-tools,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Rules-Requires-Root: no
 Homepage: https://github.com/eProsima/Fast-CDR
 Vcs-Git: https://salsa.debian.org/robotics-team/fastcdr.git
